diff -uNr mythtv-0.21/bindings/perl/IO/Socket/INET/MythTV.pm mythtv/bindings/perl/IO/Socket/INET/MythTV.pm
--- mythtv-0.21/bindings/perl/IO/Socket/INET/MythTV.pm	2007-12-01 22:49:49.000000000 +0100
+++ mythtv/bindings/perl/IO/Socket/INET/MythTV.pm	2007-12-01 22:49:49.000000000 +0100
@@ -3,8 +3,8 @@
 # A MythTV Socket class that extends IO::Socket::INET to include some
 # MythTV-specific data queries
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/bindings/perl/IO/Socket/INET/MythTV.pm $
-# @date      $Date: 2007-12-01 21:49:49 +0000 (Sat, 01 Dec 2007) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/bindings/perl/IO/Socket/INET/MythTV.pm $
+# @date      $Date: 2007-12-01 22:49:49 +0100 (Sa, 01. Dez 2007) $
 # @version   $Revision: 15016 $
 # @author    $Author: xris $
 # @copyright Silicon Mechanics
diff -uNr mythtv-0.21/bindings/perl/MythTV/Channel.pm mythtv/bindings/perl/MythTV/Channel.pm
--- mythtv-0.21/bindings/perl/MythTV/Channel.pm	2007-03-13 06:13:27.000000000 +0100
+++ mythtv/bindings/perl/MythTV/Channel.pm	2007-03-13 06:13:27.000000000 +0100
@@ -3,8 +3,8 @@
 #
 # Object containing info about a particular MythTV channel.
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/bindings/perl/MythTV/Channel.pm $
-# @date      $Date: 2007-03-13 05:13:27 +0000 (Tue, 13 Mar 2007) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/bindings/perl/MythTV/Channel.pm $
+# @date      $Date: 2007-03-13 06:13:27 +0100 (Di, 13. Mär 2007) $
 # @version   $Revision: 13029 $
 # @author    $Author: xris $
 #
diff -uNr mythtv-0.21/bindings/perl/MythTV/Program.pm mythtv/bindings/perl/MythTV/Program.pm
--- mythtv-0.21/bindings/perl/MythTV/Program.pm	2007-11-30 00:45:24.000000000 +0100
+++ mythtv/bindings/perl/MythTV/Program.pm	2007-11-30 00:45:24.000000000 +0100
@@ -3,8 +3,8 @@
 #
 # Object containing info about a particular MythTV program.
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/bindings/perl/MythTV/Program.pm $
-# @date      $Date: 2007-11-29 23:45:24 +0000 (Thu, 29 Nov 2007) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/bindings/perl/MythTV/Program.pm $
+# @date      $Date: 2007-11-30 00:45:24 +0100 (Fr, 30. Nov 2007) $
 # @version   $Revision: 14997 $
 # @author    $Author: xris $
 #
diff -uNr mythtv-0.21/bindings/perl/MythTV/Recording.pm mythtv/bindings/perl/MythTV/Recording.pm
--- mythtv-0.21/bindings/perl/MythTV/Recording.pm	2008-03-05 05:29:54.000000000 +0100
+++ mythtv/bindings/perl/MythTV/Recording.pm	2008-03-05 05:29:54.000000000 +0100
@@ -3,8 +3,8 @@
 #
 # Object containing info about a particular MythTV recording.
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/bindings/perl/MythTV/Recording.pm $
-# @date      $Date: 2008-03-05 04:29:54 +0000 (Wed, 05 Mar 2008) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/bindings/perl/MythTV/Recording.pm $
+# @date      $Date: 2008-03-05 05:29:54 +0100 (Mi, 05. Mär 2008) $
 # @version   $Revision: 16398 $
 # @author    $Author: xris $
 #
diff -uNr mythtv-0.21/bindings/perl/MythTV/StorageGroup.pm mythtv/bindings/perl/MythTV/StorageGroup.pm
--- mythtv-0.21/bindings/perl/MythTV/StorageGroup.pm	2007-01-06 21:45:00.000000000 +0100
+++ mythtv/bindings/perl/MythTV/StorageGroup.pm	2007-01-06 21:45:00.000000000 +0100
@@ -4,7 +4,7 @@
 # Object containing info about a particular MythTV Storage Group.
 #
 # @url       $URL: svn+ssh://cpinkham@cvs.mythtv.org/var/lib/svn/trunk/mythtv/bindings/perl/MythTV/StorageGroup.pm $
-# @date      $Date: 2007-01-06 20:45:00 +0000 (Sat, 06 Jan 2007) $
+# @date      $Date: 2007-01-06 21:45:00 +0100 (Sa, 06. Jan 2007) $
 # @version   $Revision: 12434 $
 # @author    $Author: xris $
 #
diff -uNr mythtv-0.21/bindings/perl/MythTV.pm mythtv/bindings/perl/MythTV.pm
--- mythtv-0.21/bindings/perl/MythTV.pm	2008-03-05 17:17:02.000000000 +0100
+++ mythtv/bindings/perl/MythTV.pm	2008-03-05 17:17:02.000000000 +0100
@@ -1,8 +1,8 @@
 #
 # MythTV bindings for perl.
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/bindings/perl/MythTV.pm $
-# @date      $Date: 2008-03-05 16:17:02 +0000 (Wed, 05 Mar 2008) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/bindings/perl/MythTV.pm $
+# @date      $Date: 2008-03-05 17:17:02 +0100 (Mi, 05. Mär 2008) $
 # @version   $Revision: 16401 $
 # @author    $Author: rkulagow $
 #
diff -uNr mythtv-0.21/contrib/channel_changers/6200ch.c mythtv/contrib/channel_changers/6200ch.c
--- mythtv-0.21/contrib/channel_changers/6200ch.c	2008-03-04 18:43:47.000000000 +0100
+++ mythtv/contrib/channel_changers/6200ch.c	2008-04-28 01:44:01.000000000 +0200
@@ -76,13 +76,14 @@
 #define DCT6416_VENDOR_ID2 0x00001a66 
 #define DCT6416_MODEL_ID1  0x0000646b
 
-#define AVC1394_SUBUNIT_TYPE_6200 (9 << 19)  /* uses a reserved subunit type */ 
+#define PACE_VENDOR_ID1    0x00005094 /* 550 & 779 */
+#define PACE550_MODEL_ID1  0x00010551
+#define PACE779_MODEL_ID1  0x00010755
 
-#define AVC1394_6200_COMMAND_CHANNEL 0x000007C00   /* 6200 subunit command */
 #define AVC1394_6200_OPERAND_SET 0x20      /* 6200 subunit command operand */
 
-#define CTL_CMD0 AVC1394_CTYPE_CONTROL | AVC1394_SUBUNIT_TYPE_6200 | \
-        AVC1394_SUBUNIT_ID_0 | AVC1394_6200_COMMAND_CHANNEL | \
+#define CTL_CMD0 AVC1394_CTYPE_CONTROL | AVC1394_SUBUNIT_TYPE_PANEL | \
+        AVC1394_SUBUNIT_ID_0 | AVC1394_PANEL_COMMAND_PASS_THROUGH | \
         AVC1394_6200_OPERAND_SET
 
 #define STARTING_NODE 1  /* skip 1394 nodes to avoid error msgs */
@@ -240,7 +241,8 @@
             (dir.vendor_id == DCT6412_VENDOR_ID1) ||
             (dir.vendor_id == DCT6412_VENDOR_ID2) ||
             (dir.vendor_id == DCT6416_VENDOR_ID1) || 
-            (dir.vendor_id == DCT6416_VENDOR_ID2)) &&
+            (dir.vendor_id == DCT6416_VENDOR_ID2) ||
+            (dir.vendor_id == PACE_VENDOR_ID1)) &&
            ((dir.model_id == DCH3200_MODEL_ID1) ||
             (dir.model_id == DCT3412_MODEL_ID1) ||
             (dir.model_id == DCT3416_MODEL_ID1) ||
@@ -250,7 +252,10 @@
             (dir.model_id == DCT6200_MODEL_ID2) ||
             (dir.model_id == DCT6412_MODEL_ID1) ||
             (dir.model_id == DCT6412_MODEL_ID2) ||
-            (dir.model_id == DCT6416_MODEL_ID1)) ) {
+            (dir.model_id == DCT6416_MODEL_ID1) ||
+            (dir.model_id == PACE550_MODEL_ID1) ||
+            (dir.model_id == PACE779_MODEL_ID1)) )
+      {
             if (dir.unit_spec_id != DCT6200_SPEC_ID)
                fprintf(stderr, "Warning: Unit Spec ID different.\n");
             if (dir.unit_sw_version != DCT6200_SW_VERSION)
diff -uNr mythtv-0.21/contrib/configfiles/lircrc.native.example.mceusb2 mythtv/contrib/configfiles/lircrc.native.example.mceusb2
--- mythtv-0.21/contrib/configfiles/lircrc.native.example.mceusb2	2006-06-12 07:18:38.000000000 +0200
+++ mythtv/contrib/configfiles/lircrc.native.example.mceusb2	2006-06-12 07:18:38.000000000 +0200
@@ -2,7 +2,7 @@
 # lircrc config file for the Microsoft Media Center Edition Remote, model 1039
 #
 # @url       $URL$
-# @date      $Date: 2006-06-12 05:18:38 +0000 (Mon, 12 Jun 2006) $
+# @date      $Date: 2006-06-12 07:18:38 +0200 (Mo, 12. Jun 2006) $
 # @version   $Revision: 10187 $
 # @author    $Author: xris $
 #
diff -uNr mythtv-0.21/contrib/icons/master_iconmap/channel_icons.pl mythtv/contrib/icons/master_iconmap/channel_icons.pl
--- mythtv-0.21/contrib/icons/master_iconmap/channel_icons.pl	2007-03-23 06:38:00.000000000 +0100
+++ mythtv/contrib/icons/master_iconmap/channel_icons.pl	2007-03-23 06:38:00.000000000 +0100
@@ -5,8 +5,8 @@
 # Also does searches for artwork URLs based on callsign or xmltvid, or displays
 # the master iconmap xml file from services.mythtv.org.
 #
-# @url       $URL: http://svn.mythtv.org/svn/tags/release-0-21/mythtv/contrib/icons/master_iconmap/channel_icons.pl $
-# @date      $Date: 2007-03-23 05:38:00 +0000 (Fri, 23 Mar 2007) $
+# @url       $URL: http://svn.mythtv.org/svn/branches/release-0-21-fixes/mythtv/contrib/icons/master_iconmap/channel_icons.pl $
+# @date      $Date: 2007-03-23 06:38:00 +0100 (Fr, 23. Mär 2007) $
 # @version   $Revision: 13114 $
 # @author    $Author: xris $
 # @copyright MythTV
diff -uNr mythtv-0.21/contrib/mythrename.pl mythtv/contrib/mythrename.pl
--- mythtv-0.21/contrib/mythrename.pl	2008-02-17 06:02:51.000000000 +0100
+++ mythtv/contrib/mythrename.pl	2008-02-17 06:02:51.000000000 +0100
@@ -7,7 +7,7 @@
 # the mythtv recording directory from the database (code from nuvexport).
 #
 # @url       $URL$
-# @date      $Date: 2008-02-17 05:02:51 +0000 (Sun, 17 Feb 2008) $
+# @date      $Date: 2008-02-17 06:02:51 +0100 (So, 17. Feb 2008) $
 # @version   $Revision: 16112 $
 # @author    $Author: xris $
 # @license   GPL
diff -uNr mythtv-0.21/contrib/optimize_mythdb.pl mythtv/contrib/optimize_mythdb.pl
--- mythtv-0.21/contrib/optimize_mythdb.pl	2007-08-04 11:25:32.000000000 +0200
+++ mythtv/contrib/optimize_mythdb.pl	2007-08-04 11:25:32.000000000 +0200
@@ -4,7 +4,7 @@
 # finds.  Suggested use is to cron it to run once per day.
 #
 # @url       $URL$
-# @date      $Date: 2007-08-04 09:25:32 +0000 (Sat, 04 Aug 2007) $
+# @date      $Date: 2007-08-04 11:25:32 +0200 (Sa, 04. Aug 2007) $
 # @version   $Revision: 14140 $
 # @author    $Author: xris $
 # @license   GPL
diff -uNr mythtv-0.21/contrib/OSX/osx-packager.pl mythtv/contrib/OSX/osx-packager.pl
--- mythtv-0.21/contrib/OSX/osx-packager.pl	2008-02-26 04:18:10.000000000 +0100
+++ mythtv/contrib/OSX/osx-packager.pl	2008-06-12 05:09:18.000000000 +0200
@@ -4,7 +4,7 @@
 ### osx-packager.pl
 ###
 ### = revision
-### $Id: osx-packager.pl 16258 2008-02-26 03:18:10Z nigel $
+### $Id: osx-packager.pl 17459 2008-06-12 03:09:18Z nigel $
 ###
 ### = location
 ### http://svn.mythtv.org/svn/trunk/mythtv/contrib/OSX/osx-packager.pl
@@ -577,6 +577,7 @@
   'mythtv'
   =>  [
         '--prefix=' . $PREFIX,
+        '--runtime-prefix=../Resources',
         # To "cross compile" something for a lesser Mac:
         #'--tune=G3',
         #'--disable-altivec',
@@ -1041,6 +1042,13 @@
 if ( $OPT{'verbose'} )
 {   push @bundler, '--verbose'   }
 
+### Framework that has a screwed up link dependency path
+my $AVCfw = '/Developer/FireWireSDK*/Examples/' .
+            'Framework/AVCVideoServices.framework';
+my @AVCfw = split / /, `ls -d $AVCfw`;
+my $AVCfw = pop @AVCfw;
+chop $AVCfw;
+
 ### Create each package.
 ### Note that this is a bit of a waste of disk space,
 ### because there are now multiple copies of each library.
@@ -1072,6 +1080,9 @@
   # Remove copy of binary
   unlink "$SCRIPTDIR/$target" or die;
 
+  if ( $AVCfw )
+  {  &RecursiveCopy($AVCfw, "$finalTarget/Contents/Frameworks")  }
+
  if ( $target eq "MythFrontend" or $target =~ m/^MythTV/ )
  {
   my $res  = "$finalTarget/Contents/Resources";
diff -uNr mythtv-0.21/contrib/Win32/MythInstaller.bat mythtv/contrib/Win32/MythInstaller.bat
--- mythtv-0.21/contrib/Win32/MythInstaller.bat	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/contrib/Win32/MythInstaller.bat	2008-06-02 05:00:06.000000000 +0200
@@ -0,0 +1,69 @@
+@rem = '--*-Perl-*--
+@rem
+@rem Wrapper for bootstrapping Windows build and install.
+@rem Checks for Perl, attempts to download latest win32-packager.pl,
+@rem and then executes that with any supplied arguments.
+@rem 
+
+@echo off
+
+if "%OS%" == "Windows_NT" setlocal
+set PERL5LIB=
+set PERLLIB=
+set PERL5OPT=
+set PERLIO=
+set PERL_UNICODE=
+if "%OS%" == "Windows_NT" goto WinNT
+perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
+goto endofperl
+
+:WinNT
+if not exist c:\perl\bin\perl.exe goto no_perl
+@rem
+@rem If we needed any non-standard Perl modules, this is how to install them:
+@rem if NOT exist C:\Perl\site\lib\Config\inifiles.pm call c:\perl\bin\ppm.bat install Config-inifiles
+@rem if errorlevel 1  echo You do not have Perl in your PATH. 
+@rem
+perl -x -S %0 %*
+if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
+if %errorlevel% == 9009 echo You do not have Perl in your PATH.
+if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
+goto endofperl
+
+:no_perl
+echo Could not find Perl in C:\Perl.
+echo Please download ActivePerl from http://www.activestate.com/store
+echo        install it, and then run this script again.
+sleep 1
+c:\windows\explorer http://www.activestate.com/store/activeperl/download
+goto endofperl
+
+@rem ';
+#!c:/perl/bin/perl.exe -w
+use strict;
+use LWP::UserAgent;
+use IO::File; 
+
+my $file = 'win32-packager.pl';
+my $url  = "http://svn.mythtv.org/svn/trunk/mythtv/contrib/Win32/build/$file";
+my $proxy = ''; # or somehting like: 'http://enter.your.proxy.here:8080';
+
+my $ua = LWP::UserAgent->new;
+$ua->proxy(['http', 'ftp'], $proxy);
+my $req = HTTP::Request->new(GET => $url);
+my $res = $ua->request($req);
+
+if ($res->is_success) {
+    my $f = new IO::File "> $file" || die "Can't create $file: $!\n";
+    $f->binmode();
+    $f->print($res->content);
+    $f->close();
+}
+
+if ( ! -s $file ) {
+    die "Cannot download $url";
+}
+
+exec "c:/perl/bin/perl.exe -w $file @ARGV";
+__END__
+:endofperl
diff -uNr mythtv-0.21/contrib/Win32/run/mythbackend.cmd mythtv/contrib/Win32/run/mythbackend.cmd
--- mythtv-0.21/contrib/Win32/run/mythbackend.cmd	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/contrib/Win32/run/mythbackend.cmd	2008-04-24 05:07:09.000000000 +0200
@@ -0,0 +1,58 @@
+@Echo off
+::
+:: Script to run mythbackend through gdb (easily?)
+:: There is likely a more efficient way of doing this, 
+:: but we have to start somewhere.
+::
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: This script is used for gathering backtraces using gdb
+Echo COMMENTS: See: http://www.mythtv.org/docs/mythtv-HOWTO-22.html#ss22.2
+Echo COMMENTS: See: http://www.mythtv.org/wiki/index.php/Windows_Port
+Echo COMMENTS: --------------------------------------
+Echo.
+::
+:gdbcommands
+::
+:: Check for and Create if needed the .\gdbcommands.txt 
+::
+:: syntax taken from [ http://www.mythtv.org/docs/mythtv-HOWTO.html#toc22.2 ] 
+::
+if not exist ./gdbcommands.txt (
+    echo handle SIGPIPE nostop noprint > .\gdbcommands.txt
+    echo handle SIG33   nostop noprint >> .\gdbcommands.txt
+    echo set logging on     >> .\gdbcommands.txt
+    echo set pagination off >> .\gdbcommands.txt
+    echo set args -l myth.log --noupnp --nosched --nojobqueue --nohousekeeper --noautoexpire -v all >> .\gdbcommands.txt
+    echo run >> .\gdbcommands.txt
+    echo thread apply all bt full >> .\gdbcommands.txt
+    echo set logging off >> .\gdbcommands.txt )
+@Echo off
+
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: Clearing old gdb.txt before running gdb again.
+Echo COMMENTS: --------------------------------------
+Echo. 
+::
+:: add current data/time to gdb.txt 
+:: will this be a bad idea? who knows? =) 
+::
+date /t > .\gdb.txt
+time /t >> .\gdb.txt
+
+:gdb
+::
+:: gdb should be in the path. 
+::
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: If you need to add any switches to mythbackend edit gdbcommands.txt
+Echo COMMENTS: see: "mythbackend.exe --help" for options
+Echo COMMENTS: --------------------------------------
+Echo.
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: Starting: gdb
+Echo COMMENTS: --------------------------------------
+gdb .\mythbackend.exe -x .\gdbcommands.txt
+
+Echo.
+Echo The backtrace can be found in .\gdb.txt
+Echo.
diff -uNr mythtv-0.21/contrib/Win32/run/mythfrontend.cmd mythtv/contrib/Win32/run/mythfrontend.cmd
--- mythtv-0.21/contrib/Win32/run/mythfrontend.cmd	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/contrib/Win32/run/mythfrontend.cmd	2008-04-24 05:07:09.000000000 +0200
@@ -0,0 +1,57 @@
+@Echo off
+::
+:: Script to run mythfrontend through gdb (easily?)
+:: There is likely a more efficient way of doing this, 
+:: but we have to start somewhere.
+::
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: This script is used for gathering backtraces using gdb
+Echo COMMENTS: See: http://www.mythtv.org/docs/mythtv-HOWTO-22.html#ss22.2
+Echo COMMENTS: See: http://www.mythtv.org/wiki/index.php/Windows_Port
+Echo COMMENTS: --------------------------------------
+Echo.
+::
+:gdbcommands
+::
+:: Check for and Create if needed the .\gdbcommands.txt 
+::
+:: syntax taken from [ http://www.mythtv.org/docs/mythtv-HOWTO.html#toc22.2 ] 
+::
+if not exist ./gdbcommands.txt (
+    echo handle SIGPIPE nostop noprint > .\gdbcommands.txt
+    echo handle SIG33   nostop noprint >> .\gdbcommands.txt
+    echo set logging on     >> .\gdbcommands.txt
+    echo set pagination off >> .\gdbcommands.txt
+    echo set args -l myth.log -d -v all >> .\gdbcommands.txt
+    echo run >> .\gdbcommands.txt
+    echo thread apply all bt full >> .\gdbcommands.txt
+    echo set logging off >> .\gdbcommands.txt )
+@Echo off
+
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: Clearing old gdb.txt before running gdb again.
+Echo COMMENTS: --------------------------------------
+Echo. 
+::
+:: add current data/time to gdb.txt 
+:: will this be a bad idea? who knows? =) 
+::
+date /t > .\gdb.txt
+time /t >> .\gdb.txt
+
+:gdb
+::
+:: gdb should be in the path. 
+::
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: If you need to add any switches to mythfrontend edit gdbcommands.txt
+Echo COMMENTS: see: "mythfrontend.exe --help" for options
+Echo COMMENTS: --------------------------------------
+Echo.
+Echo COMMENTS: --------------------------------------
+Echo COMMENTS: Starting: gdb
+Echo COMMENTS: --------------------------------------
+gdb .\mythfrontend.exe -x .\gdbcommands.txt 
+Echo.
+Echo The backtrace can be found in .\gdb.txt
+Echo.
diff -uNr mythtv-0.21/contrib/Win32/win32-packager.pl mythtv/contrib/Win32/win32-packager.pl
--- mythtv-0.21/contrib/Win32/win32-packager.pl	2008-02-26 04:18:10.000000000 +0100
+++ mythtv/contrib/Win32/win32-packager.pl	2008-06-12 05:09:18.000000000 +0200
@@ -11,7 +11,7 @@
 ### originally based loosely on osx-packager.pl, but now is its own beast.
 ###
 ### =revision
-### $Id: win32-packager.pl 16258 2008-02-26 03:18:10Z nigel $
+### $Id: win32-packager.pl 17459 2008-06-12 03:09:18Z nigel $
 ###
 ### =author
 ### David Bussenschutt
@@ -68,11 +68,13 @@
 #        it has NOT been tested much, and will with HIGH PROBABILITY fail somewhere. 
 # TODO - Only $mingw is tested and most likely is safe to change.
 
-# perl compatible paths (single forward slashes in DOS style):
-my $msys = 'C:/MSys/1.0/'; # must end in slash, and use forward slashes /
-my $sources = 'C:/msys/1.0/sources/'; # must end in slash, and use forward slashes /
-my $mingw = 'C:/MinGW/'; # must end in slash, and use forward slashes /
-my $mythtv = 'C:/mythtv/';  # this is where the entire SVN checkout lives so c:/mythtv/mythtv/ is the main codebase.  # must end in slash, and use forward slashes /
+# Perl compatible paths. DOS style, but forward slashes, and must end in slash:
+my $msys    = 'C:/MSys/1.0/';
+my $sources = 'C:/msys/1.0/sources/';
+my $mingw   = 'C:/MinGW/';
+my $mythtv  = 'C:/mythtv/';       # this is where the entire SVN checkout lives
+                                  # so c:/mythtv/mythtv/ is the main codebase.
+my $build   = 'C:/mythtv/build/'; # where 'make install' installs into
 
 # DOS executable CMD.exe versions of the paths (for when we shell to DOS mode):
 my $dosmsys    = perl2dos($msys);
@@ -80,11 +82,17 @@
 my $dosmingw   = perl2dos($mingw); 
 my $dosmythtv  = perl2dos($mythtv);
 
-# unix/msys equivalent versions of the paths (for when we shell to MSYS/UNIX mode):
-my $unixmsys = '/'; # msys root is always mounted here, irrespective of where DOS says it really is.
-my $unixmingw = '/mingw/'; # mingw is always mounted here under unix, if you setup mingw right in msys, so we will usually just say /mingw in the code, not '.$unixmingw.' or similar (see /etc/fstab)
-my $unixsources = perl2unix($sources); $unixsources =~ s#$unixmsys#/#i;  #strip leading msys path, if there, it's unnecessary as it's mounted under /
+# Unix/MSys equiv. versions of the paths (for when we shell to MSYS/UNIX mode):
+my $unixmsys  = '/';       # MSys root is always mounted here,
+                           # irrespective of where DOS says it really is.
+my $unixmingw = '/mingw/'; # MinGW is always mounted here under unix,
+                           # if you setup mingw right in msys,
+                           # so we will usually just say /mingw in the code,
+                           # not '.$unixmingw.' or similar (see /etc/fstab)
+my $unixsources = perl2unix($sources);
+$unixsources =~ s#$unixmsys#/#i;  #strip leading msys path, if there, it's unnecessary as it's mounted under /
 my $unixmythtv  = perl2unix($mythtv);
+my $unixbuild   = perl2unix($build);
 
 
 #NOTE: ITS IMPORTANT that the PATHS use the correct SLASH-ing method for the type of action:
@@ -520,7 +528,16 @@
 [ grep => ['Makefile|MAKEFILE',$mythtv.'mythtv/Makefile'], shell => ['rm '.$unixmythtv.'mythtv/Makefile','nocheck'], comment => 'broken Makefile, delete it' ],
 
 # configure
-[ file => $mythtv.'mythtv/Makefile', shell => ['source '.$unixmythtv.'qt_env.sh','cd '.$unixmythtv.'mythtv','./configure --prefix=/usr --disable-dbox2 --disable-hdhomerun --disable-dvb --disable-ivtv --disable-iptv --disable-joystick-menu --disable-xvmc-vld --disable-x11 --disable-xvmc --enable-directx --enable-memalign-hack --cpu=k8 --compile-type=debug'], comment => 'do we already have a Makefile for mythtv?' ],
+[ file => $mythtv.'mythtv/Makefile',
+ shell => ['source '.$unixmythtv.'qt_env.sh',
+           'cd '.$unixmythtv.'mythtv',
+           './configure --prefix='.$unixbuild.' --runtime-prefix=..'.
+           ' --disable-dbox2 --disable-hdhomerun'.
+           ' --disable-dvb --disable-ivtv --disable-iptv'.
+           ' --disable-joystick-menu --disable-xvmc-vld --disable-x11'.
+           ' --disable-xvmc --enable-directx'.
+           ' --enable-memalign-hack --cpu=k8 --compile-type=debug'],
+comment => 'do we already have a Makefile for mythtv?' ],
 # make
 [ newer => [$mythtv.'mythtv/libs/libmyth/libmyth-0.21.dll',$mythtv.'mythtv/last_build.txt'], shell => ['rm '.$unixmythtv.'mythtv/libs/libmyth/libmyth-0.21.dll','source '.$unixmythtv.'qt_env.sh','cd '.$unixmythtv.'mythtv','make'], comment => 'libs/libmyth/libmyth-0.21.dll - redo make unless all these files exist, and are newer than the last_build.txt identifier' ],
 [ newer => [$mythtv.'mythtv/libs/libmythtv/libmythtv-0.21.dll',$mythtv.'mythtv/last_build.txt'], shell => ['rm '.$unixmythtv.'mythtv/libs/libmythtv/libmythtv-0.21.dll','source '.$unixmythtv.'qt_env.sh','cd '.$unixmythtv.'mythtv','make'], comment => 'libs/libmythtv/libmythtv-0.21.dll - redo make unless all these files exist, and are newer than the last_build.txt identifier' ],
diff -uNr mythtv-0.21/docs/doxygen-architecture-document.cpp mythtv/docs/doxygen-architecture-document.cpp
--- mythtv-0.21/docs/doxygen-architecture-document.cpp	2008-01-07 04:04:51.000000000 +0100
+++ mythtv/docs/doxygen-architecture-document.cpp	2008-06-12 05:09:18.000000000 +0200
@@ -163,7 +163,7 @@
   <dt>osx-packager.pl   <dd>Downloads and builds all dependencies, then the
                             source, of %MythTV and all the official plugins,
                             on Mac OS 10.3 thru 10.5
-  <dt>win32-packager.pl <dd>Similar tool for Windows XP
+  <dt>win32-packager.pl <dd>Similar tool for Windows XP and Vista
 </dl>
  */
 
@@ -458,7 +458,7 @@
 
 The custom protocol is an ASCII encoded length and command string.
 Command sequences can be easily sent to the backend using telnet.
-<I>%e.g.</I> \verbatim telnet 127.0.0.1 5432
+<I>%e.g.</I> \verbatim telnet 127.0.0.1 6543
 Trying 127.0.0.1...
 Connected to localhost.
 Escape character is '^]'.\endverbatim
@@ -493,6 +493,70 @@
 
  */
 
+/** \defgroup myth_startup Myth startup sequence
+This line is filler that is ignored by Doxygen.
+
+Most MythTV programs follow a common sequence:
+<ol>
+  <li>Process (parse) command-line arguments</li>
+  <li>Create a MythContext object, which stores paths for later location
+      of runtime assets (filters/fonts/plugins/themes/translations)</li>
+  <li>(optionally) Create a UPnP client or server</li>
+  <li>Initialise the MythContext, which:</li>
+  <ul>
+    <li>Tries to find a database on localhost,
+        or on the host specified in mysql.txt,</li>
+    <li>Tries to locate exactly one backend host via UPnP,
+        to find its database,</li>
+    <li>If possible, displays a list of all backends located via UPnP
+        for the user to choose from, or</li>
+    <li>Fails</li>
+  </ul>
+  <li>Create the main window/screen, display themed menus, <i>et c.</i></li>
+</ol>
+(examine program/*/main.cpp, and libs/libmyth/mythcontext.cpp,
+for further detail).
+
+<p>
+
+The "runtime assets" mentioned above are stored in a number of well-known
+locations. The following methods in MythContext allow programs and plugins
+to access these assets:
+<ol>
+  <li>GetInstallPrefix() returns the value of MCP's m_installprefix variable,
+      which is either the runtime env. var. $MYTHTVDIR or the compile-time var.
+      RUNPREFIX. If these are relative paths, it is initialised relative to the
+      binary location. The value is used thus:
+  <ul>
+    <li>GetInstallPrefix() + /share/mythtv/ = GetShareDir(), GetFontsDir()</li>
+    <li>GetInstallPrefix() + /share/mythtv/themes/ = GetThemesParentDir()</li>
+    <li>GetInstallPrefix() + /share/mythtv/i18n/   = GetTranslationsDir()</li>
+    <li>GetInstallPrefix() + /share/mythtv/mytharchive</li>
+    <li>GetInstallPrefix() + /share/mythtv/mytharchive/themes</li>
+    <li>GetInstallPrefix() + /share/mythtv/mytharchive/scripts</li>
+    <li>GetInstallPrefix() + /share/mythtv/mythflix/scripts</li>
+    <li>GetInstallPrefix() + /share/mythtv/mythnews</li>
+    <li>GetInstallPrefix() + /share/mythtv/mythvideo/scripts</li>
+    <li>GetInstallPrefix() + /share/mythtv/mythweather</li>
+    <li>GetInstallPrefix() + /share/mythtv/mythweather/scripts</li>
+    <li>GetInstallPrefix() + /bin/ignyte</li>
+    <li>GetInstallPrefix() + /bin/mythfilldatabase</li>
+    <li>GetInstallPrefix() + /bin/mtd</li>
+    <li>GetInstallPrefix() + /lib/mythtv/ = GetLibraryDir()</li>
+    <li>GetInstallPrefix() + /lib/mythtv/plugins/ = GetPluginsDir()</li>
+    <li>GetInstallPrefix() + /lib/mythtv/filters/ = GetFiltersDir()</li>
+  </ul></li>
+
+  <li>GetConfDir() returns the value of the runtime env. var. $MYTHCONFDIR,
+      or $HOME/.mythtv.</li>
+
+  <li>mysql.txt is loaded from GetShareDir(), GetInstallPrefix() + /etc/mythtv,
+      GetConfDir(), and the current directory. Later files override the values
+      from earlier ones.</li>
+</ol>
+
+ */
+
 /** \defgroup qobject_dangers QObject is dangerous for your health
 This line is filler that is ignored by Doxygen.
 
diff -uNr mythtv-0.21/docs/doxygen-create-developer-docs.cfg mythtv/docs/doxygen-create-developer-docs.cfg
--- mythtv-0.21/docs/doxygen-create-developer-docs.cfg	2008-01-09 03:59:45.000000000 +0100
+++ mythtv/docs/doxygen-create-developer-docs.cfg	2008-05-05 17:30:02.000000000 +0200
@@ -23,7 +23,7 @@
 # This could be handy for archiving the generated documentation or 
 # if some version control system is used.
 
-PROJECT_NUMBER         = 0.20
+PROJECT_NUMBER         = 0.21
 
 # The OUTPUT_DIRECTORY tag is used to specify the (relative or absolute) 
 # base path where the generated documentation will be put. 
